Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class MemoClosure<T extends Item>

    java.lang.Object
      net.sf.saxon.value.Value<T>
          net.sf.saxon.value.Closure<T>
              net.sf.saxon.value.MemoClosure<T>

All Implemented Interfaces:
  ValueRepresentation<T>

    public class MemoClosure<T extends Item>

extends Closure<T>

A MemoClosure represents a value that has not yet been evaluated: the value is represented by an expression, together with saved values of all the context variables that the expression depends on.

The MemoClosure is designed for use when the value is only read several times. The value is saved on the first evaluation and remembered for later use.

The MemoClosure maintains a reservoir containing those items in the value that have already been read. When a new iterator is requested to read the value, this iterator first examines and returns any items already placed in the reservoir by previous users of the MemoClosure. When the reservoir is exhausted, it then uses an underlying Input Iterator to read further values of the underlying expression. If the value is not read to completion (for example, if the first user did exists($expr), then the Input Iterator is left positioned where this user abandoned it. The next user will read any values left in the reservoir by the first user, and then pick up iterating the base expression where the first user left off. Eventually, all the values of the expression will find their way into the reservoir, and future users simply iterate over the reservoir contents. Alternatively, of course, the values may be left unread.

Delayed evaluation is used only for expressions with a static type that allows more than one item, so the evaluateItem() method will not normally be used, but it is supported for completeness.

The expression may depend on local variables and on the context item; these values are held in the saved XPathContext object that is kept as part of the Closure, and they will always be read from that object. The expression may also depend on global variables; these are unchanging, so they can be read from the Bindery in the normal way. Expressions that depend on other contextual information, for example the values of position(), last(), current(), current-group(), should not be evaluated using this mechanism: they should always be evaluated eagerly. This means that the Closure does not need to keep a copy of these context variables.

In Saxon-EE, a for-each loop can be multithreaded. If a variable declared outside the loop is evaluated as a MemoClosure, then a reference to the variable within the loop can result in concurrent attempts to evaluate the variable incrementally. This is prevented by synchronizing the evaluation methods.

Nested Class Summary
`class` | `MemoClosure.ProgressiveIterator` A ProgressiveIterator starts by reading any items already held in the reservoir; when the reservoir is exhausted, it reads further items from the inputIterator, copying them into the reservoir as they are read.

Field Summary
`protected static int` | `EMPTY`
`protected int` | `state`

Fields inherited from class net.sf.saxon.value.Closure
`depth, expression, inputIterator, savedXPathContext`

Fields inherited from class net.sf.saxon.value.Value
`INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`MemoClosure()` Constructor should not be called directly, instances should be made using the make() method.

Method Summary
`int` | `getLength()` Get the length of the sequence
`boolean` | `isFullyRead()` Determine whether the contents of the MemoClosure have been fully read
`T` | `itemAt(int n)` Get the n'th item in the sequence (starting from 0).
`SequenceIterator<T>` | `iterate()` Evaluate the expression in a given context to return an iterator over a sequence
`Value` | `materialize()` Return a value containing all the items in the sequence returned by this SequenceIterator
`void` | `process(XPathContext context)` Process the expression by writing the value to the current Receiver

Methods inherited from class net.sf.saxon.value.Closure
`getCardinality, getExpression, getItemType, getSavedXPathContext, make, makeIteratorClosure, reduce, saveContext, setExpression, setSavedXPathContext`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asItem, asIterator, asValue, checkPermittedContents, convertToJava, effectiveBooleanValue, equals, fromItem, getCanonicalLexicalRepresentation, getIterator, getSchemaComparable, getSequenceLength, getStringValue, getStringValueCS, hashCode, isIdentical`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### state

    protected int state

### EMPTY

    protected static final int EMPTY

See Also:
  Constant Field Values

Constructor Detail

### MemoClosure

    public MemoClosure()

  Constructor should not be called directly, instances should be made using the make() method.

Method Detail

### iterate

    public SequenceIterator<T> iterate()
                                             throws XPathException

  Evaluate the expression in a given context to return an iterator over a sequence

  Overrides:
    `iterate` in class `Closure<T extends Item>`
  Returns:
    an iterator over the sequence of items
  Throws:
    `XPathException` - if a dynamic error occurs. This is possible only in the case of values that are materialized lazily, that is, where the iterate() method leads to computation of an expression that delivers the values.

### process

    public void process(XPathContext context)
                 throws XPathException

  Process the expression by writing the value to the current Receiver

  Overrides:
    `process` in class `Closure<T extends Item>`
  Parameters:
    `context` - The dynamic context, giving access to the current node, the current variables, etc.
  Throws:
    `XPathException` - if an error occurs (for example if the value is a closure that needs to be evaluated)

### itemAt

    public T itemAt(int n)
                          throws XPathException

  Get the n'th item in the sequence (starting from 0). This is defined for all SequenceValues, but its real benefits come for a SequenceValue stored extensionally

  Overrides:
    `itemAt` in class `Value<T extends Item>`
  Parameters:
    `n` - position of the required item, counting from zero.
  Returns:
    the n'th item in the sequence, where the first item in the sequence is numbered zero. If n is negative or >= the length of the sequence, returns null.
  Throws:
    `XPathException` - if an error occurs (for example if the value is a Closure that needs to be evaluated to find the Nth item)

### getLength

    public int getLength()
                  throws XPathException

  Get the length of the sequence

  Overrides:
    `getLength` in class `Value<T extends Item>`
  Returns:
    the number of items in the sequence
  Throws:
    `XPathException` - if an error occurs (for example if the value is a closure that needs to be read to determine its length)

### isFullyRead

    public boolean isFullyRead()

  Determine whether the contents of the MemoClosure have been fully read

  Returns:
    true if the contents have been fully read

### materialize

    public Value materialize()
                      throws XPathException

  Return a value containing all the items in the sequence returned by this SequenceIterator

  Returns:
    the corresponding value
  Throws:
    `XPathException` - if a failure occurs reading the input

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.